diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/wp-db.php ./wordpress-3.4/wp-includes/wp-db.php
*** ./wordpress-3.3.2/wp-includes/wp-db.php	2012-04-16 17:03:46.000000000 -0500
--- ./wordpress-3.4/wp-includes/wp-db.php	2012-04-16 16:55:47.000000000 -0500
***************
*** 404,412 ****
  	 * Keys are column names, values are format types: 'ID' => '%d'
  	 *
  	 * @since 2.8.0
! 	 * @see wpdb:prepare()
! 	 * @see wpdb:insert()
! 	 * @see wpdb:update()
  	 * @see wp_set_wpdb_vars()
  	 * @access public
  	 * @var array
--- 404,413 ----
  	 * Keys are column names, values are format types: 'ID' => '%d'
  	 *
  	 * @since 2.8.0
! 	 * @see wpdb::prepare()
! 	 * @see wpdb::insert()
! 	 * @see wpdb::update()
! 	 * @see wpdb::delete()
  	 * @see wp_set_wpdb_vars()
  	 * @access public
  	 * @var array
***************
*** 573,579 ****
  	function set_prefix( $prefix, $set_table_names = true ) {
  
  		if ( preg_match( '|[^a-z0-9_]|i', $prefix ) )
! 			return new WP_Error('invalid_db_prefix', /*WP_I18N_DB_BAD_PREFIX*/'Invalid database prefix'/*/WP_I18N_DB_BAD_PREFIX*/);
  
  		$old_prefix = is_multisite() ? '' : $prefix;
  
--- 574,580 ----
  	function set_prefix( $prefix, $set_table_names = true ) {
  
  		if ( preg_match( '|[^a-z0-9_]|i', $prefix ) )
! 			return new WP_Error('invalid_db_prefix', 'Invalid database prefix' );
  
  		$old_prefix = is_multisite() ? '' : $prefix;
  
***************
*** 745,758 ****
  
  		if ( !@mysql_select_db( $db, $dbh ) ) {
  			$this->ready = false;
! 			$this->bail( sprintf( /*WP_I18N_DB_SELECT_DB*/'<h1>Can&#8217;t select database</h1>
  <p>We were able to connect to the database server (which means your username and password is okay) but not able to select the <code>%1$s</code> database.</p>
  <ul>
  <li>Are you sure it exists?</li>
  <li>Does the user <code>%2$s</code> have permission to use the <code>%1$s</code> database?</li>
  <li>On some systems the name of your database is prefixed with your username, so it would be like <code>username_%1$s</code>. Could that be the problem?</li>
  </ul>
! <p>If you don\'t know how to set up a database you should <strong>contact your host</strong>. If all else fails you may find help at the <a href="http://wordpress.org/support/">WordPress Support Forums</a>.</p>'/*/WP_I18N_DB_SELECT_DB*/, htmlspecialchars( $db, ENT_QUOTES ), htmlspecialchars( $this->dbuser, ENT_QUOTES ) ), 'db_select_fail' );
  			return;
  		}
  	}
--- 746,760 ----
  
  		if ( !@mysql_select_db( $db, $dbh ) ) {
  			$this->ready = false;
! 			wp_load_translations_early();
! 			$this->bail( sprintf( __( '<h1>Can&#8217;t select database</h1>
  <p>We were able to connect to the database server (which means your username and password is okay) but not able to select the <code>%1$s</code> database.</p>
  <ul>
  <li>Are you sure it exists?</li>
  <li>Does the user <code>%2$s</code> have permission to use the <code>%1$s</code> database?</li>
  <li>On some systems the name of your database is prefixed with your username, so it would be like <code>username_%1$s</code>. Could that be the problem?</li>
  </ul>
! <p>If you don\'t know how to set up a database you should <strong>contact your host</strong>. If all else fails you may find help at the <a href="http://wordpress.org/support/">WordPress Support Forums</a>.</p>' ), htmlspecialchars( $db, ENT_QUOTES ), htmlspecialchars( $this->dbuser, ENT_QUOTES ) ), 'db_select_fail' );
  			return;
  		}
  	}
***************
*** 923,932 ****
  		if ( $this->suppress_errors )
  			return false;
  
  		if ( $caller = $this->get_caller() )
! 			$error_str = sprintf( /*WP_I18N_DB_QUERY_ERROR_FULL*/'WordPress database error %1$s for query %2$s made by %3$s'/*/WP_I18N_DB_QUERY_ERROR_FULL*/, $str, $this->last_query, $caller );
  		else
! 			$error_str = sprintf( /*WP_I18N_DB_QUERY_ERROR*/'WordPress database error %1$s for query %2$s'/*/WP_I18N_DB_QUERY_ERROR*/, $str, $this->last_query );
  
  		if ( function_exists( 'error_log' )
  			&& ( $log_file = @ini_get( 'error_log' ) )
--- 925,936 ----
  		if ( $this->suppress_errors )
  			return false;
  
+ 		wp_load_translations_early();
+ 
  		if ( $caller = $this->get_caller() )
! 			$error_str = sprintf( __( 'WordPress database error %1$s for query %2$s made by %3$s' ), $str, $this->last_query, $caller );
  		else
! 			$error_str = sprintf( __( 'WordPress database error %1$s for query %2$s' ), $str, $this->last_query );
  
  		if ( function_exists( 'error_log' )
  			&& ( $log_file = @ini_get( 'error_log' ) )
***************
*** 1037,1043 ****
  		}
  
  		if ( !$this->dbh ) {
! 			$this->bail( sprintf( /*WP_I18N_DB_CONN_ERROR*/"
  <h1>Error establishing a database connection</h1>
  <p>This either means that the username and password information in your <code>wp-config.php</code> file is incorrect or we can't contact the database server at <code>%s</code>. This could mean your host's database server is down.</p>
  <ul>
--- 1041,1048 ----
  		}
  
  		if ( !$this->dbh ) {
! 			wp_load_translations_early();
! 			$this->bail( sprintf( __( "
  <h1>Error establishing a database connection</h1>
  <p>This either means that the username and password information in your <code>wp-config.php</code> file is incorrect or we can't contact the database server at <code>%s</code>. This could mean your host's database server is down.</p>
  <ul>
***************
*** 1046,1052 ****
  	<li>Are you sure that the database server is running?</li>
  </ul>
  <p>If you're unsure what these terms mean you should probably contact your host. If you still need help you can always visit the <a href='http://wordpress.org/support/'>WordPress Support Forums</a>.</p>
! "/*/WP_I18N_DB_CONN_ERROR*/, htmlspecialchars( $this->dbhost, ENT_QUOTES ) ), 'db_connect_fail' );
  
  			return;
  		}
--- 1051,1057 ----
  	<li>Are you sure that the database server is running?</li>
  </ul>
  <p>If you're unsure what these terms mean you should probably contact your host. If you still need help you can always visit the <a href='http://wordpress.org/support/'>WordPress Support Forums</a>.</p>
! " ), htmlspecialchars( $this->dbhost, ENT_QUOTES ) ), 'db_connect_fail' );
  
  			return;
  		}
***************
*** 1073,1080 ****
  			return false;
  
  		// some queries are made before the plugins have been loaded, and thus cannot be filtered with this method
! 		if ( function_exists( 'apply_filters' ) )
! 			$query = apply_filters( 'query', $query );
  
  		$return_val = 0;
  		$this->flush();
--- 1078,1084 ----
  			return false;
  
  		// some queries are made before the plugins have been loaded, and thus cannot be filtered with this method
! 		$query = apply_filters( 'query', $query );
  
  		$return_val = 0;
  		$this->flush();
***************
*** 1191,1197 ****
  	 * @see wp_set_wpdb_vars()
  	 *
  	 * @param string $table table name
! 	 * @param array $data Data to insert (in column => value pairs).  Both $data columns and $data values should be "raw" (neither should be SQL escaped).
  	 * @param array|string $format Optional. An array of formats to be mapped to each of the value in $data. If string, that format will be used for all of the values in $data.
  	 * 	A format is one of '%d', '%f', '%s' (integer, float, string). If omitted, all values in $data will be treated as strings unless otherwise specified in wpdb::$field_types.
  	 * @param string $type Optional. What type of operation is this? INSERT or REPLACE. Defaults to INSERT.
--- 1195,1201 ----
  	 * @see wp_set_wpdb_vars()
  	 *
  	 * @param string $table table name
! 	 * @param array $data Data to insert (in column => value pairs). Both $data columns and $data values should be "raw" (neither should be SQL escaped).
  	 * @param array|string $format Optional. An array of formats to be mapped to each of the value in $data. If string, that format will be used for all of the values in $data.
  	 * 	A format is one of '%d', '%f', '%s' (integer, float, string). If omitted, all values in $data will be treated as strings unless otherwise specified in wpdb::$field_types.
  	 * @param string $type Optional. What type of operation is this? INSERT or REPLACE. Defaults to INSERT.
***************
*** 1212,1218 ****
  				$form = '%s';
  			$formatted_fields[] = $form;
  		}
! 		$sql = "{$type} INTO `$table` (`" . implode( '`,`', $fields ) . "`) VALUES ('" . implode( "','", $formatted_fields ) . "')";
  		return $this->query( $this->prepare( $sql, $data ) );
  	}
  
--- 1216,1222 ----
  				$form = '%s';
  			$formatted_fields[] = $form;
  		}
! 		$sql = "{$type} INTO `$table` (`" . implode( '`,`', $fields ) . "`) VALUES (" . implode( ",", $formatted_fields ) . ")";
  		return $this->query( $this->prepare( $sql, $data ) );
  	}
  
***************
*** 1234,1240 ****
  	 * @param array $where A named array of WHERE clauses (in column => value pairs). Multiple clauses will be joined with ANDs. Both $where columns and $where values should be "raw".
  	 * @param array|string $format Optional. An array of formats to be mapped to each of the values in $data. If string, that format will be used for all of the values in $data.
  	 * 	A format is one of '%d', '%f', '%s' (integer, float, string). If omitted, all values in $data will be treated as strings unless otherwise specified in wpdb::$field_types.
! 	 * @param array|string $where_format Optional. An array of formats to be mapped to each of the values in $where. If string, that format will be used for all of the items in $where.  A format is one of '%d', '%f', '%s' (integer, float, string).  If omitted, all values in $where will be treated as strings.
  	 * @return int|false The number of rows updated, or false on error.
  	 */
  	function update( $table, $data, $where, $format = null, $where_format = null ) {
--- 1238,1244 ----
  	 * @param array $where A named array of WHERE clauses (in column => value pairs). Multiple clauses will be joined with ANDs. Both $where columns and $where values should be "raw".
  	 * @param array|string $format Optional. An array of formats to be mapped to each of the values in $data. If string, that format will be used for all of the values in $data.
  	 * 	A format is one of '%d', '%f', '%s' (integer, float, string). If omitted, all values in $data will be treated as strings unless otherwise specified in wpdb::$field_types.
! 	 * @param array|string $where_format Optional. An array of formats to be mapped to each of the values in $where. If string, that format will be used for all of the items in $where. A format is one of '%d', '%f', '%s' (integer, float, string). If omitted, all values in $where will be treated as strings.
  	 * @return int|false The number of rows updated, or false on error.
  	 */
  	function update( $table, $data, $where, $format = null, $where_format = null ) {
***************
*** 1269,1274 ****
--- 1273,1321 ----
  	}
  
  	/**
+ 	 * Delete a row in the table
+ 	 *
+ 	 * <code>
+ 	 * wpdb::delete( 'table', array( 'ID' => 1 ) )
+ 	 * wpdb::delete( 'table', array( 'ID' => 1 ), array( '%d' ) )
+ 	 * </code>
+ 	 *
+ 	 * @since 3.4.0
+ 	 * @see wpdb::prepare()
+ 	 * @see wpdb::$field_types
+ 	 * @see wp_set_wpdb_vars()
+ 	 *
+ 	 * @param string $table table name
+ 	 * @param array $where A named array of WHERE clauses (in column => value pairs). Multiple clauses will be joined with ANDs. Both $where columns and $where values should be "raw".
+ 	 * @param array|string $where_format Optional. An array of formats to be mapped to each of the values in $where. If string, that format will be used for all of the items in $where. A format is one of '%d', '%f', '%s' (integer, float, string). If omitted, all values in $where will be treated as strings unless otherwise specified in wpdb::$field_types.
+ 	 * @return int|false The number of rows updated, or false on error.
+ 	 */
+ 	function delete( $table, $where, $where_format = null ) {
+ 		if ( ! is_array( $where ) )
+ 			return false;
+ 
+ 		$bits = $wheres = array();
+ 
+ 		$where_formats = $where_format = (array) $where_format;
+ 
+ 		foreach ( array_keys( $where ) as $field ) {
+ 			if ( !empty( $where_format ) ) {
+ 				$form = ( $form = array_shift( $where_formats ) ) ? $form : $where_format[0];
+ 			} elseif ( isset( $this->field_types[ $field ] ) ) {
+ 				$form = $this->field_types[ $field ];
+ 			} else {
+ 				$form = '%s';
+ 			}
+ 
+ 			$wheres[] = "$field = $form";
+ 		}
+ 
+ 		$sql = "DELETE FROM $table WHERE " . implode( ' AND ', $wheres );
+ 		return $this->query( $this->prepare( $sql, $where ) );
+ 	}
+ 
+ 
+ 	/**
  	 * Retrieve one variable from the database.
  	 *
  	 * Executes a SQL query and returns the value from the SQL result.
***************
*** 1278,1285 ****
  	 * @since 0.71
  	 *
  	 * @param string|null $query Optional. SQL query. Defaults to null, use the result from the previous query.
! 	 * @param int $x Optional. Column of value to return.  Indexed from 0.
! 	 * @param int $y Optional. Row of value to return.  Indexed from 0.
  	 * @return string|null Database query result (as string), or null on failure
  	 */
  	function get_var( $query = null, $x = 0, $y = 0 ) {
--- 1325,1332 ----
  	 * @since 0.71
  	 *
  	 * @param string|null $query Optional. SQL query. Defaults to null, use the result from the previous query.
! 	 * @param int $x Optional. Column of value to return. Indexed from 0.
! 	 * @param int $y Optional. Row of value to return. Indexed from 0.
  	 * @return string|null Database query result (as string), or null on failure
  	 */
  	function get_var( $query = null, $x = 0, $y = 0 ) {
***************
*** 1326,1332 ****
  		} elseif ( $output == ARRAY_N ) {
  			return $this->last_result[$y] ? array_values( get_object_vars( $this->last_result[$y] ) ) : null;
  		} else {
! 			$this->print_error(/*WP_I18N_DB_GETROW_ERROR*/" \$db->get_row(string query, output type, int offset) -- Output type must be one of: OBJECT, ARRAY_A, ARRAY_N"/*/WP_I18N_DB_GETROW_ERROR*/);
  		}
  	}
  
--- 1373,1379 ----
  		} elseif ( $output == ARRAY_N ) {
  			return $this->last_result[$y] ? array_values( get_object_vars( $this->last_result[$y] ) ) : null;
  		} else {
! 			$this->print_error( " \$db->get_row(string query, output type, int offset) -- Output type must be one of: OBJECT, ARRAY_A, ARRAY_N" );
  		}
  	}
  
***************
*** 1365,1371 ****
  	 * @param string $query SQL query.
  	 * @param string $output Optional. Any of ARRAY_A | ARRAY_N | OBJECT | OBJECT_K constants. With one of the first three, return an array of rows indexed from 0 by SQL result row number.
  	 * 	Each row is an associative array (column => value, ...), a numerically indexed array (0 => value, ...), or an object. ( ->column = value ), respectively.
! 	 * 	With OBJECT_K, return an associative array of row objects keyed by the value of each row's first column's value.  Duplicate keys are discarded.
  	 * @return mixed Database query results
  	 */
  	function get_results( $query = null, $output = OBJECT ) {
--- 1412,1418 ----
  	 * @param string $query SQL query.
  	 * @param string $output Optional. Any of ARRAY_A | ARRAY_N | OBJECT | OBJECT_K constants. With one of the first three, return an array of rows indexed from 0 by SQL result row number.
  	 * 	Each row is an associative array (column => value, ...), a numerically indexed array (0 => value, ...), or an object. ( ->column = value ), respectively.
! 	 * 	With OBJECT_K, return an associative array of row objects keyed by the value of each row's first column's value. Duplicate keys are discarded.
  	 * @return mixed Database query results
  	 */
  	function get_results( $query = null, $output = OBJECT ) {
***************
*** 1441,1448 ****
  	 * @return true
  	 */
  	function timer_start() {
! 		$mtime            = explode( ' ', microtime() );
! 		$this->time_start = $mtime[1] + $mtime[0];
  		return true;
  	}
  
--- 1488,1494 ----
  	 * @return true
  	 */
  	function timer_start() {
! 		$this->time_start = microtime( true );
  		return true;
  	}
  
***************
*** 1451,1463 ****
  	 *
  	 * @since 1.5.0
  	 *
! 	 * @return int Total time spent on the query, in milliseconds
  	 */
  	function timer_stop() {
! 		$mtime      = explode( ' ', microtime() );
! 		$time_end   = $mtime[1] + $mtime[0];
! 		$time_total = $time_end - $this->time_start;
! 		return $time_total;
  	}
  
  	/**
--- 1497,1506 ----
  	 *
  	 * @since 1.5.0
  	 *
! 	 * @return float Total time spent on the query, in seconds
  	 */
  	function timer_stop() {
! 		return ( microtime( true ) - $this->time_start );
  	}
  
  	/**
***************
*** 1546,1561 ****
  	 * @return string The name of the calling function
  	 */
  	function get_caller() {
! 		$trace  = array_reverse( debug_backtrace() );
! 		$caller = array();
! 
! 		foreach ( $trace as $call ) {
! 			if ( isset( $call['class'] ) && __CLASS__ == $call['class'] )
! 				continue; // Filter out wpdb calls.
! 			$caller[] = isset( $call['class'] ) ? "{$call['class']}->{$call['function']}" : $call['function'];
! 		}
! 
! 		return join( ', ', $caller );
  	}
  
  	/**
--- 1589,1595 ----
  	 * @return string The name of the calling function
  	 */
  	function get_caller() {
! 		return wp_debug_backtrace_summary( __CLASS__ );
  	}
  
  	/**
***************
*** 1569,1573 ****
  		return preg_replace( '/[^0-9.].*/', '', mysql_get_server_info( $this->dbh ) );
  	}
  }
- 
- ?>
--- 1603,1605 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/wp-diff.php ./wordpress-3.4/wp-includes/wp-diff.php
*** ./wordpress-3.3.2/wp-includes/wp-diff.php	2011-04-30 12:18:39.000000000 -0500
--- ./wordpress-3.4/wp-includes/wp-diff.php	2012-01-08 11:01:11.000000000 -0600
***************
*** 202,210 ****
  		$r = '';
  
  		// Does the aforementioned additional processing
! 		// *_matches tell what rows are "the same" in orig and final.  Those pairs will be diffed to get word changes
  		//	match is numeric: an index in other column
! 		//	match is 'X': no match.  It is a new row
  		// *_rows are column vectors for the orig column and the final column.
  		//	row >= 0: an indix of the $orig or $final array
  		//	row  < 0: a blank row for that column
--- 202,210 ----
  		$r = '';
  
  		// Does the aforementioned additional processing
! 		// *_matches tell what rows are "the same" in orig and final. Those pairs will be diffed to get word changes
  		//	match is numeric: an index in other column
! 		//	match is 'X': no match. It is a new row
  		// *_rows are column vectors for the orig column and the final column.
  		//	row >= 0: an indix of the $orig or $final array
  		//	row  < 0: a blank row for that column
***************
*** 231,237 ****
  					$stripped_diff = strlen(strip_tags( $diff )) * 2 - $stripped_matches;
  					$diff_ratio = $stripped_matches / $stripped_diff;
  					if ( $diff_ratio > $this->_diff_threshold )
! 						continue; // Too different.  Don't save diffs.
  				}
  
  				// Un-inline the diffs by removing del or ins
--- 230,236 ----
  					$stripped_diff = strlen(strip_tags( $diff )) * 2 - $stripped_matches;
  					$diff_ratio = $stripped_matches / $stripped_diff;
  					if ( $diff_ratio > $this->_diff_threshold )
! 						continue; // Too different. Don't save diffs.
  				}
  
  				// Un-inline the diffs by removing del or ins
***************
*** 241,251 ****
  		}
  
  		foreach ( array_keys($orig_rows) as $row ) {
! 			// Both columns have blanks.  Ignore them.
  			if ( $orig_rows[$row] < 0 && $final_rows[$row] < 0 )
  				continue;
  
! 			// If we have a word based diff, use it.  Otherwise, use the normal line.
  			if ( isset( $orig_diffs[$orig_rows[$row]] ) )
  				$orig_line = $orig_diffs[$orig_rows[$row]];
  			elseif ( isset( $orig[$orig_rows[$row]] ) )
--- 240,250 ----
  		}
  
  		foreach ( array_keys($orig_rows) as $row ) {
! 			// Both columns have blanks. Ignore them.
  			if ( $orig_rows[$row] < 0 && $final_rows[$row] < 0 )
  				continue;
  
! 			// If we have a word based diff, use it. Otherwise, use the normal line.
  			if ( isset( $orig_diffs[$orig_rows[$row]] ) )
  				$orig_line = $orig_diffs[$orig_rows[$row]];
  			elseif ( isset( $orig[$orig_rows[$row]] ) )
***************
*** 260,268 ****
  			else
  				$final_line = '';
  
! 			if ( $orig_rows[$row] < 0 ) { // Orig is blank.  This is really an added row.
  				$r .= $this->_added( array($final_line), false );
! 			} elseif ( $final_rows[$row] < 0 ) { // Final is blank.  This is really a deleted row.
  				$r .= $this->_deleted( array($orig_line), false );
  			} else { // A true changed row.
  				$r .= '<tr>' . $this->deletedLine( $orig_line ) . $this->addedLine( $final_line ) . "</tr>\n";
--- 259,267 ----
  			else
  				$final_line = '';
  
! 			if ( $orig_rows[$row] < 0 ) { // Orig is blank. This is really an added row.
  				$r .= $this->_added( array($final_line), false );
! 			} elseif ( $final_rows[$row] < 0 ) { // Final is blank. This is really a deleted row.
  				$r .= $this->_deleted( array($orig_line), false );
  			} else { // A true changed row.
  				$r .= '<tr>' . $this->deletedLine( $orig_line ) . $this->addedLine( $final_line ) . "</tr>\n";
***************
*** 288,294 ****
  	 */
  	function interleave_changed_lines( $orig, $final ) {
  
! 		// Contains all pairwise string comparisons.  Keys are such that this need only be a one dimensional array.
  		$matches = array();
  		foreach ( array_keys($orig) as $o ) {
  			foreach ( array_keys($final) as $f ) {
--- 287,293 ----
  	 */
  	function interleave_changed_lines( $orig, $final ) {
  
! 		// Contains all pairwise string comparisons. Keys are such that this need only be a one dimensional array.
  		$matches = array();
  		foreach ( array_keys($orig) as $o ) {
  			foreach ( array_keys($final) as $f ) {
***************
*** 309,315 ****
  			if ( isset($orig_matches[$o]) && isset($final_matches[$f]) )
  				continue;
  
! 			// First match for these guys.  Must be best match
  			if ( !isset($orig_matches[$o]) && !isset($final_matches[$f]) ) {
  				$orig_matches[$o] = $f;
  				$final_matches[$f] = $o;
--- 308,314 ----
  			if ( isset($orig_matches[$o]) && isset($final_matches[$f]) )
  				continue;
  
! 			// First match for these guys. Must be best match
  			if ( !isset($orig_matches[$o]) && !isset($final_matches[$f]) ) {
  				$orig_matches[$o] = $f;
  				$final_matches[$f] = $o;
***************
*** 342,352 ****
  
  			if ( false === $final_pos ) { // This orig is paired with a blank final.
  				array_splice( $final_rows, $orig_pos, 0, -1 );
! 			} elseif ( $final_pos < $orig_pos ) { // This orig's match is up a ways.  Pad final with blank rows.
  				$diff_pos = $final_pos - $orig_pos;
  				while ( $diff_pos < 0 )
  					array_splice( $final_rows, $orig_pos, 0, $diff_pos++ );
! 			} elseif ( $final_pos > $orig_pos ) { // This orig's match is down a ways.  Pad orig with blank rows.
  				$diff_pos = $orig_pos - $final_pos;
  				while ( $diff_pos < 0 )
  					array_splice( $orig_rows, $orig_pos, 0, $diff_pos++ );
--- 340,350 ----
  
  			if ( false === $final_pos ) { // This orig is paired with a blank final.
  				array_splice( $final_rows, $orig_pos, 0, -1 );
! 			} elseif ( $final_pos < $orig_pos ) { // This orig's match is up a ways. Pad final with blank rows.
  				$diff_pos = $final_pos - $orig_pos;
  				while ( $diff_pos < 0 )
  					array_splice( $final_rows, $orig_pos, 0, $diff_pos++ );
! 			} elseif ( $final_pos > $orig_pos ) { // This orig's match is down a ways. Pad orig with blank rows.
  				$diff_pos = $orig_pos - $final_pos;
  				while ( $diff_pos < 0 )
  					array_splice( $orig_rows, $orig_pos, 0, $diff_pos++ );
***************
*** 427,433 ****
  		// L1-norm of difference vector.
  		$difference = array_sum( array_map( array(&$this, 'difference'), $chars1, $chars2 ) );
  
! 		// $string1 has zero length? Odd.  Give huge penalty by not dividing.
  		if ( !$string1 )
  			return $difference;
  
--- 424,430 ----
  		// L1-norm of difference vector.
  		$difference = array_sum( array_map( array(&$this, 'difference'), $chars1, $chars2 ) );
  
! 		// $string1 has zero length? Odd. Give huge penalty by not dividing.
  		if ( !$string1 )
  			return $difference;
  
***************
*** 473,477 ****
  	}
  
  }
- 
- ?>
--- 470,472 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-load.php ./wordpress-3.4/wp-load.php
*** ./wordpress-3.3.2/wp-load.php	2011-11-15 09:47:07.000000000 -0600
--- ./wordpress-3.4/wp-load.php	2012-04-22 03:05:17.000000000 -0500
***************
*** 18,24 ****
   * @package WordPress
   */
  
! /** Define ABSPATH as this files directory */
  define( 'ABSPATH', dirname(__FILE__) . '/' );
  
  error_reporting( E_CORE_ERROR | E_CORE_WARNING | E_COMPILE_ERROR | E_ERROR | E_WARNING | E_PARSE | E_USER_ERROR | E_USER_WARNING | E_RECOVERABLE_ERROR );
--- 18,24 ----
   * @package WordPress
   */
  
! /** Define ABSPATH as this file's directory */
  define( 'ABSPATH', dirname(__FILE__) . '/' );
  
  error_reporting( E_CORE_ERROR | E_CORE_WARNING | E_COMPILE_ERROR | E_ERROR | E_WARNING | E_PARSE | E_USER_ERROR | E_USER_WARNING | E_RECOVERABLE_ERROR );
***************
*** 30,36 ****
  
  } elseif ( file_exists( dirname(ABSPATH) . '/wp-config.php' ) && ! file_exists( dirname(ABSPATH) . '/wp-settings.php' ) ) {
  
! 	/** The config file resides one level above ABSPATH but is not part of another install*/
  	require_once( dirname(ABSPATH) . '/wp-config.php' );
  
  } else {
--- 30,36 ----
  
  } elseif ( file_exists( dirname(ABSPATH) . '/wp-config.php' ) && ! file_exists( dirname(ABSPATH) . '/wp-settings.php' ) ) {
  
! 	/** The config file resides one level above ABSPATH but is not part of another install */
  	require_once( dirname(ABSPATH) . '/wp-config.php' );
  
  } else {
***************
*** 39,60 ****
  
  	// Set a path for the link to the installer
  	if ( strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false )
! 		$path = '';
  	else
! 		$path = 'wp-admin/';
  
! 	require_once( ABSPATH . '/wp-includes/load.php' );
! 	require_once( ABSPATH . '/wp-includes/version.php' );
  	define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
  	wp_check_php_mysql_versions();
  
  	// Die with an error message
! 	require_once( ABSPATH . '/wp-includes/class-wp-error.php' );
! 	require_once( ABSPATH . '/wp-includes/functions.php' );
! 	require_once( ABSPATH . '/wp-includes/plugin.php' );
! 	$text_direction = /*WP_I18N_TEXT_DIRECTION*/'ltr'/*/WP_I18N_TEXT_DIRECTION*/;
! 	wp_die(sprintf(/*WP_I18N_NO_CONFIG*/"<p>There doesn't seem to be a <code>wp-config.php</code> file. I need this before we can get started.</p> <p>Need more help? <a href='http://codex.wordpress.org/Editing_wp-config.php'>We got it</a>.</p> <p>You can create a <code>wp-config.php</code> file through a web interface, but this doesn't work for all server setups. The safest way is to manually create the file.</p><p><a href='%ssetup-config.php' class='button'>Create a Configuration File</a></p>"/*/WP_I18N_NO_CONFIG*/, $path), /*WP_I18N_ERROR_TITLE*/'WordPress &rsaquo; Error'/*/WP_I18N_ERROR_TITLE*/, array('text_direction' => $text_direction));
  
  }
- 
- ?>
\ No newline at end of file
--- 39,61 ----
  
  	// Set a path for the link to the installer
  	if ( strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false )
! 		$path = 'setup-config.php';
  	else
! 		$path = 'wp-admin/setup-config.php';
  
! 	define( 'WPINC', 'wp-includes' );
  	define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
+ 	require_once( ABSPATH . WPINC . '/load.php' );
+ 	require_once( ABSPATH . WPINC . '/version.php' );
+ 
+ 	wp_load_translations_early();
  	wp_check_php_mysql_versions();
  
  	// Die with an error message
! 	$die  = __( "There doesn't seem to be a <code>wp-config.php</code> file. I need this before we can get started." ) . '</p>';
! 	$die .= '<p>' . __( "Need more help? <a href='http://codex.wordpress.org/Editing_wp-config.php'>We got it</a>." ) . '</p>';
! 	$die .= '<p>' . __( "You can create a <code>wp-config.php</code> file through a web interface, but this doesn't work for all server setups. The safest way is to manually create the file." ) . '</p>';
! 	$die .= '<p><a href="' . $path . '" class="button">' . __( "Create a Configuration File" ) . '</a>';
  
+ 	wp_die( $die, __( 'WordPress &rsaquo; Error' ) );
  }
